% Implements: L. Saul and M. Jordan (1996)
% Exploiting Tractable Substructures in Intractable Networks
% NIPS
%
% Author: Jean Honorio
% E-mail: jhonorio@csail.mit.edu
function [logZ obj m] = log_partition_meanfield_ising(W,b,epsilon);

if ~exist('epsilon','var')
    epsilon = 1e-2;
end
N = size(W,1);
b = b(:);
m = zeros(N,1);
obj = [];
t = 0;
while true
    t = t+1;
    for n = 1:N
        m(n) = max(min(tanh(W(n,:)*m+b(n)),1-epsilon),-1+epsilon);
    end
    obj(t) = m.'*W*m/2 + b.'*m - sum(((1+m)/2).*log((1+m)/2) + ((1-m)/2).*log((1-m)/2));
    if t > 1 & obj(t) - obj(t-1) <= epsilon
        break
    end
end
logZ = obj(end);
